#include <sourcemod>
#include <autoexecconfig>
#include <cstrike>
#include <stamm>

new Handle:g_hStammPoints = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = "Restrict CT",
	author = "Bara",
	description = "Erlaubt CT erst ab X Stammpunkte",
	version = "1.0.0",
	url = "www.bara.in"
}

public OnPluginStart()
{
	AutoExecConfig_SetFile("plugin.restrict.ct", "sourcemod");
	AutoExecConfig_SetCreateFile(true);
	g_hStammPoints = AutoExecConfig_CreateConVar("restrict_ct_points", "50", "Wie viele brauchen Spieler um ins CT Team zu joinen?");
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();

	AddCommandListener(Command_CheckJoin, "jointeam");

	CreateTimer(5.0, Timer_CheckClient, _, TIMER_REPEAT);
}

public Action:Command_CheckJoin(client, const String:command[], args)
{
	if(!STAMM_IsAvailable() || !STAMM_IsClientValid(client))
	{
		return Plugin_Continue;
	}
	
	decl String:teamString[3];
	GetCmdArg(1, teamString, sizeof(teamString));
	new Target_Team = StringToInt(teamString);

	new StammPoints = GetConVarInt(g_hStammPoints);
	new ClientPoints = STAMM_GetClientPoints(client);
	if ((Target_Team == CS_TEAM_SPECTATOR || Target_Team == CS_TEAM_T))
	{
		return Plugin_Continue;
	}
	else if(Target_Team == CS_TEAM_CT)
	{
		if(ClientPoints < StammPoints)
		{
			PrintCenterText(client, "Sie haben nicht genug Stammpunkte!");
			UTIL_TeamMenu(client);
			return Plugin_Stop;
		}
	}
	
	return Plugin_Continue;
}

public Action:Timer_CheckClient(Handle:timer)
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if(STAMM_IsClientValid(client))
		{
			if(GetClientTeam(client) == CS_TEAM_CT)
			{
				new StammPoints = GetConVarInt(g_hStammPoints);
				new ClientPoints = STAMM_GetClientPoints(client);

				if(ClientPoints < StammPoints)
				{
					PrintCenterText(client, "Sie haben nicht genug Stammpunkte!");
					ChangeClientTeam(client, CS_TEAM_T);
					UTIL_TeamMenu(client);
					return Plugin_Stop;
				}
			}
		}
	}
	
	return Plugin_Continue;
}

UTIL_TeamMenu(client)
{
	new clients[1];
	new Handle:bf;
	clients[0] = client;
	bf = StartMessage("VGUIMenu", clients, 1);
	
	if (GetUserMessageType() == UM_Protobuf)
	{
		PbSetString(bf, "name", "team");
		PbSetBool(bf, "show", true);
	}
	else
	{
		BfWriteString(bf, "team");
		BfWriteByte(bf, 1);
		BfWriteByte(bf, 0);
	}

	EndMessage();
}